<script lang="ts" setup>
import type { DevSurveyIntro } from './Intro.vue';

interface ReportHero {
  year: string;
  title: string;
  config?: {
    imgSrc?: string;
    mobileImgSrc?: string;
  };
}

defineProps<{
  hero: ReportHero;
  intro: DevSurveyIntro;
}>();
</script>

<template>
  <div class="intro">
    <section class="hero">
      <SlpContainer>
        <div v-if="hero.config?.mobileImgSrc" class="mobile-image-container">
          <img preload data-aos="fade-left" :data-aos-duration="700" :src="hero.config?.mobileImgSrc" alt="" />
        </div>
        <div class="hero__flex">
          <div class="hero__text">
            <h1>
              <span class="hero__text--year" data-aos="fade-up" data-aos-duration="700">
                {{ hero.year }}
              </span>
              <span class="hero__text--text" data-aos="fade-up" data-aos-duration="1000">
                {{ hero.title }}
              </span>
            </h1>
          </div>
          <div class="hero__image--container">
            <img
              preload
              data-aos="fade-left"
              :data-aos-duration="700"
              :src="hero.config?.imgSrc ? hero.config?.imgSrc : '/images/developer-survey/2024/2024-survey-hero.png'"
              alt=""
            />
          </div>
        </div>
      </SlpContainer>
    </section>
    <section>
      <SlpContainer>
        <Devsurvey2024Header :text="intro.surveyHeader.text" :img-variant="1" class="slp-mb-32" />
        <div class="accordion-grid">
          <Devsurvey2024Accordion
            v-if="intro.summary"
            :data="intro.summary"
            background-color="#fff"
            class="summary"
            :open-by-default="true"
          />
          <Devsurvey2024Accordion
            v-if="intro.highlights"
            :data="intro.highlights"
            background-color="#F6F3FE"
            class="highlights"
          >
            <Devsurvey2024Carousel :data="intro.highlights" />
          </Devsurvey2024Accordion>
        </div>
      </SlpContainer>
    </section>
  </div>
</template>

<style lang="scss" scoped>
.intro {
  padding-bottom: 96px;

  @media (max-width: $breakpoint-md) {
    padding-bottom: 8px;
  }

  &:deep(.intro-text) {
    font-size: 32px;
    line-height: 40px;

    @media (max-width: $breakpoint-md) {
      font-size: 16px;
      line-height: 24px;
    }
  }

  &:deep(.slide) {
    min-height: 250px;
    justify-content: center;
  }

  &:deep(.slide__text) {
    font-size: 18px;
    font-weight: $font-weight-bold;
    line-height: 28px;
  }
}
.hero {
  color: #232150;
  padding: 96px 0;
  position: relative;
  background: linear-gradient(179deg, #d7fefe 0.88%, #f8f8f8 99.07%);
  @media (max-width: $breakpoint-md) {
    padding: 0 0 16px 0;
  }
  &:before {
    @media (min-width: $breakpoint-lg) {
      content: '';
      background: url('/images/developer-survey/2024/2024-survey-hero-bg-pills.png');
      background-size: contain;
      background-repeat: no-repeat;
      position: absolute;
      top: 0;
      left: 20%;
      z-index: 3;
      width: 3000px;
      height: 600px;
    }

    @media (max-width: $breakpoint-md) {
      content: '';
      background: url('/images/developer-survey/2024/2024-survey-hero-bg-pills.png');
      background-size: contain;
      background-repeat: no-repeat;
      position: absolute;
      top: 0;
      left: 20%;
      z-index: 3;
      width: 3000px;
      height: 400px;
    }
  }

  .mobile-image-container {
    display: none;
    @media (max-width: $breakpoint-md) {
      display: block;
      position: relative;
      min-height: 165px;

      img {
        position: absolute;
        top: 0;
        left: -20px;
      }
    }
  }

  &__flex {
    display: flex;
    align-items: center;
    gap: 45px;
  }

  &__image--container {
    z-index: 4;
    flex: 1 0 30%;
    position: relative;

    @media (max-width: $breakpoint-md) {
      display: none;
    }

    img {
      width: 100%;
      height: auto;
      z-index: 0;
    }
  }

  &__text {
    flex: 1 0 40%;
    z-index: 5;
    position: relative;
    padding-bottom: 32px;

    &--year {
      display: block;
      font-family: 'GitLab Mono';
      font-weight: $font-weight-bold;
      margin-bottom: 24px;
      font-size: 24px;
      line-height: 18px;
      margin-bottom: 8px;

      @media (max-width: $breakpoint-md) {
        font-size: 16px;
      }
    }

    &--text {
      display: block;
      font-weight: $font-weight-bold;
      font-size: 96px;
      font-style: normal;
      line-height: 100px;
      letter-spacing: -2.88px;
      @media (max-width: $breakpoint-md) {
        font-size: 40px;
        line-height: 48px;
        letter-spacing: -1.2px;
      }
    }
  }
}

.accordion-grid {
  display: flex;
  justify-content: space-between;
  gap: 32px;
  flex-wrap: nowrap;
  flex-direction: row;

  @media (max-width: $breakpoint-md) {
    flex-direction: column;
    gap: 16px;
  }

  .summary,
  .highlights {
    flex: 1 0 50%;
  }
}
</style>
